// SyntaxSample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <conio.h>


//*************************************************************************************
// Class CTest
//*************************************************************************************
class CTest
{
public:
   typedef MEMBER_FUNCTION_CALL_TYPEDEF1( CTest, int, OwnCall );

   CTest( CDelegate1<int>& delegate )
   {
      delegate.Add( *this, (OwnCall) Test );
   }

   void  Test( int iValue )
   {
      cout << "CTest member function called with " << iValue << endl;
   }
};
//*************************************************************************************


//*************************************************************************************
// Function Test
//*************************************************************************************
void Test( int iValue )
{
   cout << "Test static function called with " << iValue << endl;
}
//*************************************************************************************


//*************************************************************************************
// Main
//*************************************************************************************
int main(int argc, char* argv[])
{
   // Delegate Declaration
   CDelegate1<int> delegate;

   // Execute Delegate : do nothing
   delegate( 0 );
   
   // Build Test Object (Test member function suscribes to delegate)
   CTest test( delegate );

   // Execute delegate : execute test.Test( 0 )
   cout << "Execute 0: (CTest only)" << endl;
   cout << "-----------------------" << endl;
   delegate( 0 );
   cout << endl << endl;

   // Add Test Static Function
   delegate.Add( Test );

   // Remove test.Test subscription
   delegate.Remove( test, CTest::Test );

   // Execute delegate : execute Test( 1 )
   cout << "Execute 1: (Test Only)" << endl;
   cout << "----------------------" << endl;
   delegate( 1 );
   cout << endl << endl;

   // Add test.Test:
   delegate.Add( test, CTest::Test );

   // Execute delegate : Test( 2 ) & test.Test( 2 )
   cout << "Execute 2: (Test & CTest)" << endl;
   cout << "-------------------------" << endl;
   delegate( 2 );
   cout << endl << endl;

   cout << "press any key to continue..." << endl;
   getch( );

	return 0;
}
//*************************************************************************************
