// BasicSampleView.cpp : implementation of the CBasicSampleView class
//

#include "stdafx.h"
#include "BasicSample.h"

#include "BasicSampleDoc.h"
#include "BasicSampleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//*************************************************************************************
// For clearer reading
//*************************************************************************************
#define OwnCall MEMBER_FUNCTION_CALL2( CBasicSampleView, int, int )
//*************************************************************************************


//*************************************************************************************
IMPLEMENT_DYNCREATE(CBasicSampleView, CView)
//*************************************************************************************


//*************************************************************************************
BEGIN_MESSAGE_MAP(CBasicSampleView, CView)
	//{{AFX_MSG_MAP(CBasicSampleView)
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_SHOW_COORD, OnShowCoord)
	ON_COMMAND(ID_HILIGHT, OnHilight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//*************************************************************************************


//*************************************************************************************
// CBasicSampleView construction/destruction
//*************************************************************************************
CBasicSampleView::CBasicSampleView()
:  m_curCell( -1, -1 ),
   m_prevCell( -1, -1 )
{
	// TODO: add construction code here

}
//*************************************************************************************
CBasicSampleView::~CBasicSampleView()
{
}
//*************************************************************************************
BOOL CBasicSampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}
//*************************************************************************************
void CBasicSampleView::GetCellRect( int iCol, int iRow, CRect& rcCell ) const
{
   CBasicSampleDoc* pDoc = ((CBasicSampleView*)(this))->GetDocument();

   ASSERT_VALID(pDoc);
   ASSERT( iCol < pDoc->Cols( ) && iRow < pDoc->Rows( ) );
   
   CRect rcClient;
   GetClientRect( &rcClient );

   CSize szCell( rcClient.Width( ) / pDoc->Cols( ), 
                 rcClient.Height( ) / pDoc->Rows( ) );


   rcCell.left   = szCell.cx * iCol;
   rcCell.top    = szCell.cy * iRow;
   rcCell.right  = rcCell.left + szCell.cx;
   rcCell.bottom = rcCell.top + szCell.cy;
}
//*************************************************************************************
void CBasicSampleView::HilightCell( int iCol, int iRow )
{
   CDC* pDC = GetDC( );
   assert( pDC );
   
   CRect rcCell;
   GetCellRect( iCol, iRow, rcCell );

   pDC->InvertRect( &rcCell );
}
//*************************************************************************************
void CBasicSampleView::ShowCoords( int iCol, int iRow )
{
   CDC* pDC = GetDC( );
   assert( pDC );
 
   CRect rcCell;
   GetCellRect( iCol, iRow, rcCell );

   CString sCoord;
   sCoord.Format( "(%d:%d)", iCol, iRow );
   pDC->SetTextColor( RGB( 180, 0, 0 ) );
   int iOldMode = pDC->SetBkMode( TRANSPARENT );
   pDC->SelectStockObject( DEFAULT_GUI_FONT );
   pDC->DrawText( sCoord, rcCell, DT_SINGLELINE|DT_LEFT|DT_TOP );
   pDC->SetBkMode( iOldMode );
}
//*************************************************************************************



//*************************************************************************************
// CBasicSampleView drawing
//*************************************************************************************
void CBasicSampleView::OnDraw(CDC* pDC)
{
	CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   // Draw grid

   CRect rcClient;
   GetClientRect( &rcClient );

   CSize szCell( rcClient.Width( ) / pDoc->Cols( ), 
                 rcClient.Height( ) / pDoc->Rows( ) );
   
   for( int I = pDoc->Cols( )*szCell.cx; (I -= szCell.cx) >= 0; )
   {
      pDC->MoveTo( CPoint( I, rcClient.top ) );
      pDC->LineTo( CPoint( I, rcClient.bottom ) );
   }

   for( I = pDoc->Rows( )*szCell.cy; (I -= szCell.cy) >= 0; )
   {
      pDC->MoveTo( CPoint( rcClient.left, I ) );
      pDC->LineTo( CPoint( rcClient.right, I ) );
   }
}
//*************************************************************************************


//*************************************************************************************
// CBasicSampleView diagnostics
//*************************************************************************************
#ifdef _DEBUG
//*************************************************************************************
void CBasicSampleView::AssertValid() const
{
	CView::AssertValid();
}
//*************************************************************************************
void CBasicSampleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
//*************************************************************************************
CBasicSampleDoc* CBasicSampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBasicSampleDoc)));
	return (CBasicSampleDoc*)m_pDocument;
}
//*************************************************************************************
#endif //_DEBUG
//*************************************************************************************


//*************************************************************************************
// CBasicSampleView message handlers
//*************************************************************************************
void CBasicSampleView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
   CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   m_MouseEvents.SetSize( pDoc->Size( ) );
   for( int I = pDoc->Size( ); --I >= 0; )
   {
      m_MouseEvents[ I ].Clear( );
      m_MouseEvents[ I ].Add( *this, (OwnCall) ShowCoords );
   }

   m_curCell.x = -1;
   m_curCell.y = -1;
   m_prevCell  = m_curCell;

   Invalidate( );
   UpdateWindow( );
}
//*************************************************************************************
void CBasicSampleView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
   Invalidate( );
   UpdateWindow( );
}
//*************************************************************************************
void CBasicSampleView::OnMouseMove(UINT nFlags, CPoint point) 
{
   CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   CRect rcClient;
   GetClientRect( &rcClient );

   CSize szCell( rcClient.Width( ) / pDoc->Cols( ), 
                 rcClient.Height( ) / pDoc->Rows( ) );

   m_curCell.x = (point.x / szCell.cx);
   m_curCell.y = (point.y / szCell.cy);

   if( m_curCell != m_prevCell )
   {
      // Restore old Cell
      CRect rcOldCell;
      GetCellRect( m_prevCell.x, m_prevCell.y, rcOldCell );
      InvalidateRect( &rcOldCell );
      UpdateWindow( );
      
      if( m_curCell.x >= pDoc->Cols( ) || 
          m_curCell.y >= pDoc->Rows( ) )
      {
         m_curCell.x = -1;
         m_curCell.y = -1;
         m_prevCell = m_curCell;
         return;
      }

      // Special effect on new Cell
      int idx = pDoc->Converter( ).ToIdx( m_curCell.x, m_curCell.y );
      ASSERT( idx >= 0 && idx < pDoc->Size( ) );
      m_MouseEvents[ idx ]( m_curCell.x, m_curCell.y );

      m_prevCell = m_curCell;
   }

	CView::OnMouseMove(nFlags, point);
}
//*************************************************************************************
void CBasicSampleView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
   CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   CMenu menu;
   menu.LoadMenu( IDR_CONTEXT );
   CMenu* pPopup = menu.GetSubMenu(0);

   int idx = pDoc->Converter( ).ToIdx( m_curCell.x, m_curCell.y );
   ASSERT( idx >= 0 && idx < pDoc->Size( ) );

   if( m_MouseEvents[ idx ].Has( *this, (OwnCall) ShowCoords ) )
      pPopup->CheckMenuItem( ID_SHOW_COORD, MF_BYCOMMAND|MF_CHECKED );
   else
      pPopup->CheckMenuItem( ID_SHOW_COORD, MF_BYCOMMAND|MF_UNCHECKED );

   if( m_MouseEvents[ idx ].Has( *this, (OwnCall) HilightCell ) )
      pPopup->CheckMenuItem( ID_HILIGHT, MF_BYCOMMAND|MF_CHECKED );
   else
      pPopup->CheckMenuItem( ID_HILIGHT, MF_BYCOMMAND|MF_UNCHECKED );

   pPopup->TrackPopupMenu( TPM_RIGHTBUTTON|TPM_RIGHTALIGN, point.x, point.y, pWnd );
}
//*************************************************************************************
void CBasicSampleView::OnShowCoord() 
{
   CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   int idx = pDoc->Converter( ).ToIdx( m_curCell.x, m_curCell.y );
   ASSERT( idx >= 0 && idx < pDoc->Size( ) );

   if( m_MouseEvents[ idx ].Has( *this, (OwnCall) ShowCoords ) )
      m_MouseEvents[ idx ].Remove( *this, (OwnCall) ShowCoords );
   else
      m_MouseEvents[ idx ].Add( *this, (OwnCall) ShowCoords );
}
//*************************************************************************************
void CBasicSampleView::OnHilight() 
{
   CBasicSampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

   int idx = pDoc->Converter( ).ToIdx( m_curCell.x, m_curCell.y );
   ASSERT( idx >= 0 && idx < pDoc->Size( ) );

   if( m_MouseEvents[ idx ].Has( *this, (OwnCall) HilightCell ) )
      m_MouseEvents[ idx ].Remove( *this, (OwnCall) HilightCell );
   else
      m_MouseEvents[ idx ].Add( *this, (OwnCall) HilightCell );
}
//*************************************************************************************
